//+------------------------------------------------------------------+
//|                                               Puria.mq4 Modified |
//|       Copyright 12.2010, Oleg Tsiliuric (based on (c)2010, AM2)  |
//|                                           Vers. 4.4, 28.12.2010  |
//+------------------------------------------------------------------+
#property copyright " 2010, Oleg Tsiliuric"
#property link      "olej@front.ru"

#define MagicBuy  765432
#define MagicSell 876543

extern int RiskPercent      = 3;        //   -  1 : 0-100% 
extern int StopLoss         = 350;
extern int TakeProfit       = 700;
extern int MovingPeriod1    = 5;
extern int MovingPeriod2    = 75;
extern int MovingPeriod3    = 85;
extern bool Bezubitok       = false;
extern int DebugLevel       = 0;

static bool Working = true;

//-------------------------------------------------------------------
void start() {
   static int nBars = 0;
   static bool Begin = true;
   static bool BuyOne = true, SellOne = true;
   if( !Working || Bars<100 || IsTradeAllowed()==false ) return;
   if( Begin==false ) {                                //     ! 
      if( nBars == Bars ) {                            //     ...
         Sleep( 200 );
         return;
      }
      else {
         bool First = ( nBars == 0 );
         nBars = Bars;
         if( First ) return;
         if( DebugLevel > 1 ) Alert( "  : ", nBars );      
      }
   }
   //<===        !
   double ma1, ma2, ma3, macd;
   ma1  = iMA( NULL, 0, MovingPeriod1, 0, MODE_EMA, PRICE_CLOSE, 1 );
   ma2  = iMA( NULL, 0, MovingPeriod2, 0, MODE_LWMA, PRICE_LOW, 1 );
   ma3  = iMA( NULL, 0, MovingPeriod3, 0, MODE_LWMA, PRICE_LOW, 1 );
   macd = iMACD( NULL, 0, 15, 26, 1, PRICE_CLOSE, MODE_MAIN, 1 );
   if( Begin ) {                                          //    MA
      if( ma1>ma2 && ma1>ma3 ) {
         BuyOne = false; SellOne = true; Begin = false;
      }
      if( ma1<ma2 && ma1<ma3 ) {
         SellOne = false; BuyOne = true; Begin = false;
      }  
      return;
   }
   if( DebugLevel > 0 ) {                                 //   
      int Draft = iCustom( NULL, 0, "iPuria", 
                           MovingPeriod1, MovingPeriod2, MovingPeriod3, 
                           0, 0 );
   }                           
//------------  (SL)    ---------------
   int Dist = MarketInfo( Symbol(), MODE_STOPLEVEL );     //   -      
   if( StopLoss < Dist ) {
      StopLoss = Dist;                                    //  
      if( DebugLevel > 0 ) Alert( " : StopLoss=", Dist );
   }
   if( TakeProfit < Dist ) {
      TakeProfit = Dist;                                  //  
      if( DebugLevel > 0 ) Alert( " : TakeProfit=", Dist );
   }
   PrevOrdersModify();
//----------      ----------------
   int Ticket;  
   double Lot = Lots();
//----------------     -----------------------
#define TRY_COUNTER 3
   int Try = TRY_COUNTER;                                 //   
   while( Try > 0 ) {
      int ErrorChr;                                       //    
      Try--;
      RefreshRates();                                     //        
      if( ma1<ma2 && ma1<ma3 ) {   /* SELL */
         BuyOne = true;                                   //   
         if( macd<0 && SellOne ) {
            OppositClose( OP_SELL );                      //    
            Ticket = OrderSend( Symbol(), OP_SELL, Lot, Bid, 3,
                                Ask + StopLoss * Point, Ask - TakeProfit * Point,
                                "", MagicSell, 0, Red );                                
            if( Ticket>0 ) SellOne = false;               // ...
            else {    
               ErrorChr = Fun_Error( GetLastError() );
               if( ErrorChr==1 ) continue;                //   -  
               else if( ErrorChr==-1 ) Working = false;   //  
            }
         }
      } /* SELL */
      if( ma1>ma2 && ma1>ma3 ) {   /* BUY */
         SellOne = true;                                   //         
         if( macd>0 && BuyOne ) { 
            OppositClose( OP_BUY );                        //    
            Ticket = OrderSend( Symbol(), OP_BUY, Lot, Ask, 3,
                                Bid - StopLoss * Point, Bid + TakeProfit * Point,
                                "", MagicBuy, 0, Blue );
            if(  Ticket>0 ) BuyOne = false;                // ...
            else {    
               ErrorChr = Fun_Error( GetLastError() );
               if( ErrorChr==1 ) continue;                 //   -  
               else if( ErrorChr==-1 ) Working = false;    //  
            }
         }
      } /* BUY */
      return;                                              //   start()   
   } /* while */ 
} /* start() */
//-------------------------------------------------------------------
double AccountStart,                                          //    
       Min_Lot,                                               // . . 
       Max_Lot,                                               // . . 
       LotSize;                                               //    
void init() {
   AccountStart = AccountFreeMargin();                        //     
   if( RiskPercent<=0 || RiskPercent>100 ) {
      Alert( "RiskPercent     0..100:  " );
      Working = false;                                        //   ! ...
      return;
   }
   string Symb = Symbol();   
   double Lot = MarketInfo( Symb, MODE_MARGINREQUIRED );      //  1- 
   LotSize = ( AccountStart * RiskPercent / 100. ) / Lot;
   if( DebugLevel > 0 ) {
      Alert( "Point = ", DoubleToStr( Point, 6 ), ",   = ", Lot,
             ",  = ", AccountStart, ",  = ", LotSize );
   }
   Min_Lot = MarketInfo( Symb, MODE_MINLOT );                 // . . 
   Max_Lot = MarketInfo( Symb, MODE_MAXLOT );                 // . . 
   return;                                                    //   init()   
}
//--------------------------------------------------------------------
//-------------  (SL)    --------------
void PrevOrdersModify() {
   if( !Bezubitok ) return;
   for( int j=0; j<OrdersTotal(); j++ ) {
      if( OrderSelect( j, SELECT_BY_POS )==true ) {          //   
         if( OrderSymbol()!=Symbol() ) continue;             //   . 
         int Tip = OrderType();                              //   
         if( Tip!=OP_BUY && Tip!=OP_SELL ) continue;         //   
         int Ticket = OrderTicket();                         //   
         double NewLoss;
         if( Tip==OP_SELL ) { // SELL
            if( OrderMagicNumber()!=MagicSell ) continue;    //     Sell
            if( OrderStopLoss()<=OrderOpenPrice() ) continue;//   
            NewLoss = Ask + ( Point * StopLoss );
            if( NewLoss < OrderOpenPrice() ) NewLoss = OrderOpenPrice();
            if( NewLoss < OrderStopLoss() ) ModifyStopLoss( OP_BUY, NewLoss );
         }            
         if( Tip==OP_BUY ) {  // BUY
            if( OrderMagicNumber()!=MagicBuy ) continue;     //     Buy
            if( OrderStopLoss()>=OrderOpenPrice() ) continue;//   
            NewLoss = Bid - ( Point * StopLoss );
            if( NewLoss > OrderOpenPrice() ) NewLoss = OrderOpenPrice();
            if( NewLoss > OrderStopLoss() ) ModifyStopLoss( OP_BUY, NewLoss );
         }
      }
   }
}
//--------------------------------------------------------------------
void ModifyStopLoss( int op, double Stop ) {
   double StopLevel = NormalizeDouble( Stop, Digits );
   int Try = TRY_COUNTER;                                 //   
   while( Try > 0 ) {
      Try--;
      while( !IsTradeAllowed() ) Sleep( 5000 );
      RefreshRates();
      if( OrderModify( OrderTicket(), OrderOpenPrice(),
                       StopLevel , OrderTakeProfit(),
                       0, Green ) ) {
         return;
      }
      else {
         int ErrorChr = Fun_Error( GetLastError() );      //    
         if( ErrorChr==1 ) continue;                      //   -  
         else return;                                     //  
      }
   }
}
//----------------    -----------------------
void OppositClose( int Opr ) {
   int j = 0; 
   while( j<OrdersTotal() ) {                                //  for -  !
      j++;   
      if( OrderSelect( j - 1, SELECT_BY_POS )==true ) {      //   
         int Ticket = OrderTicket();                         //   
         if( OrderSymbol()!= Symbol() ) continue;            //   . 
         int Tip;                                            //   
         Tip = OrderType();            
         if( Tip!=OP_BUY && Tip!=OP_SELL ) continue;         //   
         if( Tip==Opr ) continue;                            //   
         if( Tip==OP_BUY && OrderMagicNumber()!=MagicBuy )   //     Buy
            continue;
         if( Tip==OP_SELL && OrderMagicNumber()!=MagicSell ) //     Sell
            continue;
         double Lot;                                         //       
         Lot = OrderLots();                                  // .   .
         RefreshRates();                                     //  
         int Try = TRY_COUNTER;                              //   
         while( Try > 0 ) {
            Try--;
            while( !IsTradeAllowed() ) Sleep( 5000 );
            bool Ansv;
            if( Tip==OP_BUY ) Ansv = OrderClose( Ticket, Lot, Bid, 3 );
            if( Tip==OP_SELL ) Ansv = OrderClose( Ticket, Lot, Ask, 3 );
            if( Ansv==true ) {                               //  !
               j = 0;                                        //    !
               break;
            }
            int ErrorChr = Fun_Error( GetLastError() );
            continue;
         }
      }      
   }
}
//------------------    -------------------------
double Lots() {
   string Symb = Symbol();                                    //  
   double Lots = LotSize;
   double Step = MarketInfo( Symb, MODE_LOTSTEP );            //   
   Lots = MathFloor( Lots / Step ) * Step;                    //   
   Lots = MathMin( Max_Lot, MathMax( Min_Lot, Lots ) );       //   
   
return( Lots );                              //   !

   Lots = AccountFreeMargin() / AccountStart * LotSize;
   if( Lots<0.1 ) Lots = NormalizeDouble( Lots, 2 );
   else if( Lots<1 ) Lots = NormalizeDouble( Lots, 1 );
   else Lots = NormalizeDouble( Lots, 0 );
return( Lots );   

   return( Lots );
}
//---------------------------------------------------------------------
#include "Fun_Error.mqh"

